<div mat-subheader>Observable command</div>

<div id="contents">
    <app-parameter-area [feature]="feature" [command]="command"></app-parameter-area>
    <app-metadata-area [serverUuid]="server.serveruuid!" [feature]="feature" [item]="command"></app-metadata-area>

    <div class="mb-3">
        <button [disabled]="hubConnection" mat-raised-button color="primary" (click)="executeObservableCommand()">Execute command</button>
        <button *ngIf="serverSupportsCancellation" [disabled]="!hubConnection" mat-raised-button color="primary" (click)="cancelCommandExecution()" class="ms-3">Cancel command</button>
    </div>
    <mat-progress-bar mode="determinate" [value]="commandState ? (commandState.progress * 100).toFixed() : 0"></mat-progress-bar>
    <div *ngIf="commandState">
        Command state:
        <span *ngIf="commandState.state == 0">Not started</span>
        <span *ngIf="commandState.state == 1">Running</span>
        <span *ngIf="commandState.state == 2">Finished with errors</span>
        <span *ngIf="commandState.state == 3">Finished successfully</span>
    </div>
    <div *ngIf="commandState">Estimated remaining time: {{commandState.estimatedRemainingTime}}</div>

    <app-intermediate-value-area [hidden]="!command.intermediateResponse || !intermediateAreaVisible" [feature]="feature" [command]="command"></app-intermediate-value-area>
    <app-result-area [hidden]="!resultAreaVisible" [feature]="feature" [command]="command"></app-result-area>
    <app-error-area [hidden]="!errorAreaVisible" [definedExecutionErrors]="feature.definedExecutionErrors || []"></app-error-area>
</div>
